$dato = Read-Host -Prompt 'Digite su dominio o correo con inconvenientes'

if($dato -clike '*@*') {
	$datoTemporal =$dato.Split("@")
	$dominio=$datoTemporal[1]
}else{
	$dominio=$dato
}

$dominio=$dominio.Trim()

$mxdominio=Resolve-DnsName -Name ${dominio} -Type MX | select "NameExchange" | select-object -ExpandProperty NameExchange | Select -First 1

Function Obtener-Externo{
Param ($puertoE)

	$servidor = switch ($puertoE) {
		"143" {"imap.airmail.net";break}
		"110" {"pop.airmail.net";break}
		"25" {"smtp.sendgrid.net";break}
		"587" {"smtp.sendgrid.net";break}
		"465" {"smtp.sendgrid.net";break}
		"110" {"smtp.sendgrid.net";break}
		"110" {"smtp.sendgrid.net";break}
		"993" {"pop.airmail.net";break}
		"995" {"pop.airmail.net";break}
		default  { ""; break}
	}

	return $servidor
}

Function Probar-Puerto{
Param ([string]$myhostT, $puertoT)

	$timeout=5000

	try{
	        $tcpclient = New-Object -TypeName system.Net.Sockets.TcpClient
	        $iar = $tcpclient.BeginConnect($myhostT,$puertoT,$null,$null)
	        $wait = $iar.AsyncWaitHandle.WaitOne($timeout,$false)
	        if(!$wait){
	            $tcpclient.Close()
		    return $false
		}else{
		    # Close the connection and report the error if there is one
		           
		    $null = $tcpclient.EndConnect($iar)
		    $tcpclient.Close()
		    return $true
		}
	}catch {
		$false
	}
}


Function Procesar-Prueba{
Param ([string]$myhost, $puerto, $nombre, $intentarExterno)

$estado=Probar-Puerto $myhost $puerto
	if($estado){
		Write-Host "$myhost : puerto $puerto ($nombre) : OK"
	}else{
		if($intentarExterno){
			$servidorExterno=Obtener-Externo $puerto
			
			if(Probar-Puerto $servidorExterno $puerto){
				$externo="E_OK"
			}else{
				$externo="E_NO"
			}
			Write-Host "$myhost : puerto $puerto ($nombre) : NO : ${externo}"
		}else{
			Write-Host "$myhost : puerto $puerto ($nombre) : NO"
		}
	}
}


$ipPublica=(((nslookup myip.opendns.com resolver1.opendns.com 2> $null| select-string -pattern "Address:") -split ":")[3]).Trim()

Write-Host "################### Pruebas de Conectividad ########################"
Write-Host "###### IP Publica de su conexion a Internet: $ipPublica ######"

Write-Host ""
Write-Host "###### Probando puertos de correo #######"
Procesar-Prueba "$mxdominio" 25 smtp 1
Procesar-Prueba "$mxdominio" 26 smtp_alt 0

Procesar-Prueba $mxdominio 587 smtp_ssl 1 
Procesar-Prueba $mxdominio 465 smtp_ssl_alt 1 
Procesar-Prueba $mxdominio 143 imap 1 
Procesar-Prueba $mxdominio 993 imap_ssl 1 
Procesar-Prueba $mxdominio 110 pop 1 
Procesar-Prueba $mxdominio 995 pop_ssl 1 

Write-Host ""
Write-Host "###### Probando puertos de web #######"
Procesar-Prueba $dominio 80 http 0 
Procesar-Prueba $dominio 443 https 0 

Write-Host ""
Write-Host "###### Probando puertos de administracion #######"
Procesar-Prueba $dominio 2083 cpanel 0 
Procesar-Prueba $dominio 8443 plesk 0 
Procesar-Prueba $dominio 2096 webmail 0 
Procesar-Prueba $dominio 21 ftp 0 

Write-Host ""
Write-Host "###### Probando PING #######"
Test-NetConnection $dominio

Write-Host "###### Probando Tracert #######"
Test-NetConnection $dominio -TraceRoute 2>&1

Write-Host "POR FAVOR ENVIAR PANTALLAZO CON LA INFORMACION ANTERIOR"
Write-Host "AL CORREO soporte@colombiahosting.com.co"
Write-Host ""
Read-Host -Prompt "Presione Enter para cerrar"

